summaryrefslogtreecommitdiff
path: root/.gitlab/wait-for-emulator.sh
diff options
context:
space:
mode:
authorcyBerta <cyberta@riseup.net>2018-02-06 16:28:34 +0100
committercyBerta <cyberta@riseup.net>2018-02-06 16:28:34 +0100
commit3d827e7295d37ecb25332b39057338496f6f970d (patch)
treef8c5272e125ed9abae72fb3598d25b1c09f06f89 /.gitlab/wait-for-emulator.sh
parent646e2ec7b868920f71c29243d2bbeb13deb811e3 (diff)
parentedd34192484f4eb618fdcc2a68b18168c155d63c (diff)
Merge branch 'origin_0.9.8' into 8823_cw_tablet_layout
Diffstat (limited to '.gitlab/wait-for-emulator.sh')
-rwxr-xr-x.gitlab/wait-for-emulator.sh44
1 files changed, 44 insertions, 0 deletions
diff --git a/.gitlab/wait-for-emulator.sh b/.gitlab/wait-for-emulator.sh
new file mode 100755
index 00000000..cd51428a
--- /dev/null
+++ b/.gitlab/wait-for-emulator.sh
@@ -0,0 +1,44 @@
+#!/bin/bash
+
+# from https://gitlab.com/fdroid/fdroidclient
+
+sec=0
+timeout=360
+
+err() {
+ echo "$@"
+ exit 1
+}
+
+explain() {
+ if [[ "$1" =~ "not found" ]]; then
+ printf "device not found"
+ elif [[ "$1" =~ "offline" ]]; then
+ printf "device offline"
+ elif [[ "$1" =~ "running" ]]; then
+ printf "booting"
+ else
+ printf "$1"
+ fi
+}
+
+while true; do
+ if [[ $sec -ge $timeout ]]; then
+ err "Timeout ($timeout seconds) reached - Failed to start emulator"
+ fi
+ out=$(adb -e shell getprop init.svc.bootanim 2>&1 | grep -v '^\*')
+ if [[ "$out" =~ "command not found" ]]; then
+ err "$out"
+ fi
+ if [[ "$out" =~ "stopped" ]]; then
+ break
+ fi
+ let "r = sec % 5"
+ if [[ $r -eq 0 ]]; then
+ echo "Waiting for emulator to start: $(explain "$out")"
+ fi
+ sleep 1
+ let "sec++"
+done
+
+echo "Emulator is ready"